unit nguCliente;


interface

uses
  acuframework, utuMessage;

type
  ngCliente = class(acPersistentObject)
  private
    FNome: acString;
    FCPF: acString;
    FAtivo: acString;
    fEmprestimos: acRelationPartnerList;
  public
    procedure toXML(piField: utField);
  published
    property Nome: acString read FNome write FNome;
    property CPF: acString read FCPF write FCPF;
    property Ativo: acString read FAtivo write FAtivo;
    property Emprestimos: acRelationPartnerList read fEmprestimos write fEmprestimos;
  end;

implementation

procedure ngCliente.toXML(piField: utField);
begin
  piField.AddAttribute('OID').AsString := Self.IDO.AsString;
  piField.AddAttribute('Nome').AsString := Self.Nome.AsString;
  piField.AddAttribute('CPF').AsString := Self.CPF.AsString;
end;

initialization

PersistenceManager.RegisterClass(ngCliente);

end.
